# TypeScript <3
- The problem
    - JS can be really difficult to work with on large applications.
    - Dyanamic typing means it is difficult to know what properties an object has or a function returns.
    - JS type coercion means sometimes you are working with a different type then you are expeting.
    - JS is very tolerant  of things like improper method parameters
- Microsoft created a new programming called TypeScript
- TypeScript is a **optionally statically** type version of JS
- It is a ***Super Set*** of JavaScript
    - It can do ANYTHING JS can do in addition to extra features
    - Any valid JS is valid TS
- VS Code is a actually written in TypeScript
- TS cannot actually be executed
- TS is ***Transpiled*** into JS
